"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetSupervisors = exports.SupervisorMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function SupervisorMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.SupervisorMSSql = SupervisorMSSql;
function GetSupervisors(vcc) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('GetSupervisors')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var supervisors = [];
        recordset.map(function (r) {
            var supervisor = {};
            supervisor.userId = r.userId;
            supervisor.userName = r.userName;
            supervisor.campaigns = [];
            supervisors.push(supervisor);
        });
        return Promise.resolve(supervisors);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetSupervisors = GetSupervisors;
