"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveVersionRegistration = exports.GetVersion = exports.VersionMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function VersionMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.VersionMSSql = VersionMSSql;
function GetVersion() {
    return new sql.Request(sqlConn)
        .execute('GetVersion')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var version = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(version);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[VersionMSSql::GetVersion] Getting error:', errorMsg);
        return Promise.reject(err);
    });
}
exports.GetVersion = GetVersion;
function SaveVersionRegistration(installationId, buildVersion) {
    return new sql.Request(sqlConn)
        .input('InstallationId', sql.VarChar(100), installationId)
        .input('BuildVersion', sql.VarChar(25), buildVersion)
        .execute('SaveVersionRegistration')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[VersionMSSql::SaveVersionRegistration] Getting error:', errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveVersionRegistration = SaveVersionRegistration;
