"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BulkTemplateThemeItem = exports.BulkTemplateThemeItemTemp = exports.BulkTemplateTheme = exports.BulkTemplateThemeTemp = exports.DeleteTemplateTheme = exports.DeleteTemplate = exports.SaveTemplateThemeItem = exports.SaveTemplateTheme = exports.SaveTemplate = exports.SaveTemplateThemeItemEntity = exports.GetTemplateThemeItemEntities = exports.GetTemplateThemeItemById = exports.GetTemplateThemeModels = exports.GetTemplateThemeItems = exports.GetTemplateThemes = exports.GetTemplateByName = exports.GetTemplate = exports.GetTemplatesVCC = exports.GetTemplates = exports.TemplateMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function TemplateMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.TemplateMSSql = TemplateMSSql;
function GetTemplates(vcc, type, search_criteria, search_expression, language) {
    if (language === void 0) { language = 'en'; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.VarChar(50), type)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('Language', sql.VarChar(5), language)
        .execute('GetTemplates')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplates = GetTemplates;
function GetTemplatesVCC(vcc) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('GetTemplatesVCC')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplatesVCC = GetTemplatesVCC;
function GetTemplate(vcc, name) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .execute('GetTemplate')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var template = (recordset && recordset.length > 0 ? recordset[0] : null);
        if (template) {
            recordset = (recordsets && recordsets.length > 1 ? recordsets[1] : null);
            template.templateThemes = (recordset ? recordset : null);
        }
        return Promise.resolve(template);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplate = GetTemplate;
function GetTemplateByName(vcc, type, name) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.VarChar(50), type)
        .input('Name', sql.VarChar(50), name)
        .execute('GetTemplateByName')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var template = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(template);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateByName = GetTemplateByName;
function GetTemplateThemes(vcc, templateId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .execute('GetTemplateThemes')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemes = GetTemplateThemes;
function GetTemplateThemeItems(vcc, templateId, templateThemeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(50), templateThemeId)
        .execute('GetTemplateThemeItems')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeItems = GetTemplateThemeItems;
function GetTemplateThemeModels(vcc, templateId, templateThemeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(50), templateThemeId)
        .execute('GetTemplateThemeModels')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeModels = GetTemplateThemeModels;
function GetTemplateThemeItemById(vcc, id) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .execute('GetTemplateThemeItemById')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeItemById = GetTemplateThemeItemById;
function GetTemplateThemeItemEntities(vcc, abilityQueryId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateThemeItemId', sql.VarChar(50), abilityQueryId)
        .execute('GetTemplateThemeItemEntities')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeItemEntities = GetTemplateThemeItemEntities;
function SaveTemplateThemeItemEntity(vcc, templateId, templateThemeId, templateThemeItemId, entityId, entityName, acceptancePercentage, order, createdByUserId, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(50), templateThemeId)
        .input('TemplateThemeItemId', sql.VarChar(50), templateThemeItemId)
        .input('EntityId', sql.VarChar(50), entityId)
        .input('EntityName', sql.VarChar(50), entityName)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveTemplateThemeItemEntity')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplateThemeItemEntity = SaveTemplateThemeItemEntity;
function SaveTemplate(vcc, name, type, description, template, category, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .input('Type', sql.VarChar(50), type)
        .input('Description', sql.VarChar(50), description)
        .input('Template', sql.VarChar(50), template)
        .input('Category', sql.VarChar(50), category)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveTemplate')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplate = SaveTemplate;
function SaveTemplateTheme(vcc, templateId, id, order, description, category1, category2, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, analysisType, isNegative) {
    if (analysisType === void 0) { analysisType = 'SEMANTIC'; }
    if (isNegative === void 0) { isNegative = false; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('ID', sql.VarChar(200), id)
        .input('Order', sql.Int, order)
        .input('Description', sql.VarChar(50), description)
        .input('Category1', sql.VarChar(50), category1)
        .input('Category2', sql.VarChar(50), category2)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('AnalysisType', sql.VarChar(15), analysisType)
        .input('IsNegative', sql.Bit, isNegative)
        .execute('SaveTemplateTheme')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplateTheme = SaveTemplateTheme;
function SaveTemplateThemeItem(vcc, templateId, templateThemeId, id, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, acceptancePercentage) {
    if (acceptancePercentage === void 0) { acceptancePercentage = 0; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(200), templateThemeId)
        .input('ID', sql.VarChar(50), id)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('AcceptancePercentage', sql.Decimal(5, 2), acceptancePercentage)
        .execute('SaveTemplateThemeItem')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplateThemeItem = SaveTemplateThemeItem;
function DeleteTemplate(vcc, name, type) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .execute('DeleteTemplate')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteTemplate = DeleteTemplate;
function DeleteTemplateTheme(vcc, name, type) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(200), name)
        .execute('DeleteTemplateTheme')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteTemplateTheme = DeleteTemplateTheme;
function TransactionBulkTemplateTheme(table, methodValidator, nameTable) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('TransactionBulkTemplateTheme: Creando solicitud');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(table)
            .then(function (rowCount) {
            logger.info('TransactionBulkTemplateTheme: Bulk se insertaron : ' + rowCount + ' en la tabla temporal ' + nameTable);
            return true;
        })
            .catch(function (err) {
            logger.error('TransactionBulkTemplateTheme: Al realizar el bulk: ' + err.message + ' en la tabla temporal ' + nameTable);
            throw err;
        });
    })
        .then(function (rowCount) {
        logger.info('TransactionBulkTemplateTheme: Paso de la data de la tabla temporal a la tabla final');
        return methodValidator(request);
    })
        .then(function (result) {
        logger.info('TransactionBulkTemplateTheme: Guardando la transaccion');
        return transaction.commit();
    })
        .then(function (result) {
        return Promise.resolve(true);
    })
        .catch(function (err) {
        transaction.rollback();
        logger.error('TransactionBulkTemplateTheme: Error al realizar el parseo: ' + err.message);
        return Promise.reject(err);
    });
}
function BulkTemplateThemeTemp(vcc, customTemplate, customTemplateId, data) {
    var table = new sql.Table('#TemplateThemeTemp');
    table.create = true;
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('TemplateId', sql.VarChar(50), { nullable: true });
    table.columns.add('ID', sql.VarChar(50), { nullable: true });
    table.columns.add('Order', sql.Int, { nullable: true });
    table.columns.add('Description', sql.VarChar(50), { nullable: true });
    table.columns.add('Category1', sql.VarChar(50), { nullable: true });
    table.columns.add('Category2', sql.VarChar(50), { nullable: true });
    table.columns.add('CreatedDate', sql.DateTime, { nullable: true });
    table.columns.add('CreatedByUserId', sql.VarChar(50), { nullable: true });
    table.columns.add('LastModifiedDate', sql.DateTime, { nullable: true });
    table.columns.add('LastModifiedByUserId', sql.VarChar(50), { nullable: true });
    for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
        var row = data_1[_i];
        table.rows.add(vcc, customTemplateId, row.id, row.order, row.description, row.category1, row.category2, customTemplate.createdDate, customTemplate.createdByUserId, customTemplate.lastModifiedDate, customTemplate.lastModifiedByUserId);
    }
    logger.info('BulkTemplateThemeTemp: Parseo Correcto');
    return TransactionBulkTemplateTheme(table, BulkTemplateTheme, '#TemplateThemeTemp');
}
exports.BulkTemplateThemeTemp = BulkTemplateThemeTemp;
function BulkTemplateTheme(request) {
    return request.execute('BulkTemplateTheme')
        .then(function (recordset) {
        logger.info('BulkTemplateTheme: Ejecucion Correcta BulkTemplateTheme');
        return Promise.resolve(true);
    })
        .catch(function (err) {
        logger.error('BulkTemplateTheme: Al ejecutar el procedure BulkTemplateTheme : ' + err.message);
        return Promise.reject(err);
    });
}
exports.BulkTemplateTheme = BulkTemplateTheme;
function TransactionBulkTemplateThemeItem(table, methodValidator, nameTable) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('TransactionBulkTemplateThemeItem: Creando solicitud');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(table)
            .then(function (rowCount) {
            logger.info('TransactionBulkTemplateThemeItem: Bulk se insertaron : ' + rowCount + ' en la tabla temporal ' + nameTable);
            return true;
        })
            .catch(function (err) {
            logger.error('TransactionBulkTemplateThemeItem: Al realizar el bulk: ' + err.message + ' en la tabla temporal ' + nameTable);
            throw err;
        });
    })
        .then(function (rowCount) {
        logger.info('TransactionBulkTemplateThemeItem: Paso de la data de la tabla temporal a la tabla final');
        return methodValidator(request);
    })
        .then(function (result) {
        logger.info('TransactionBulkTemplateThemeItem: Guardando la transaccion');
        return transaction.commit();
    })
        .then(function (result) {
        return Promise.resolve(true);
    })
        .catch(function (err) {
        transaction.rollback();
        logger.error('TransactionBulkTemplateThemeItem: Error al realizar el parseo: ' + err.message);
        return Promise.reject(err);
    });
}
function BulkTemplateThemeItemTemp(vcc, customTemplate, customTemplateId, data) {
    var table = new sql.Table('#TemplateThemeItemTemp');
    table.create = true;
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('TemplateId', sql.VarChar(50), { nullable: true });
    table.columns.add('TemplateThemeId', sql.VarChar(50), { nullable: true });
    table.columns.add('ID', sql.VarChar(50), { nullable: true });
    table.columns.add('CreatedDate', sql.DateTime, { nullable: true });
    table.columns.add('CreatedByUserId', sql.VarChar(50), { nullable: true });
    table.columns.add('LastModifiedDate', sql.DateTime, { nullable: true });
    table.columns.add('LastModifiedByUserId', sql.VarChar(50), { nullable: true });
    for (var _i = 0, data_2 = data; _i < data_2.length; _i++) {
        var row = data_2[_i];
        table.rows.add(vcc, customTemplateId, row.templateThemeId, row.id, customTemplate.createdDate, customTemplate.createdByUserId, customTemplate.lastModifiedDate, customTemplate.lastModifiedByUserId);
    }
    logger.info('BulkTemplateThemeItemTemp: Parseo Correcto');
    return TransactionBulkTemplateThemeItem(table, BulkTemplateThemeItem, '#TemplateThemeItemTemp');
}
exports.BulkTemplateThemeItemTemp = BulkTemplateThemeItemTemp;
function BulkTemplateThemeItem(request) {
    return request.execute('BulkTemplateThemeItem')
        .then(function (recordset) {
        logger.info('BulkTemplateThemeItem: Ejecucion Correcta BulkTemplateThemeItem');
        return Promise.resolve(true);
    })
        .catch(function (err) {
        logger.error('BulkTemplateThemeItem: Al ejecutar el procedure BulkTemplateThemeItem : ' + err.message);
        return Promise.reject(err);
    });
}
exports.BulkTemplateThemeItem = BulkTemplateThemeItem;
