"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UtteranceData = exports.UtteranceObject = exports.Utterance = void 0;
var Utterance = (function () {
    function Utterance(name, intent, appId) {
        this.name = name;
        this.intent = intent;
        this.appId = appId;
        this.selected = false;
        this.id = null;
        this.entityLabels = [];
        this.intentId = null;
        this.key = null;
        this.intentKey = null;
        this.status = 0;
        this.totalRetries = 0;
        this.rawEntityLabels = null;
    }
    return Utterance;
}());
exports.Utterance = Utterance;
var UtteranceObject = (function () {
    function UtteranceObject() {
        this.id = null;
        this.text = null;
        this.intentId = null;
        this.intentName = null;
        this.intentLabel = null;
        this.intentPredictions = [];
        this.entityLabels = [];
        this.entityPredictions = [];
        this.multiIntentPredictions = null;
        this.tokenizedText = [];
    }
    return UtteranceObject;
}());
exports.UtteranceObject = UtteranceObject;
var UtteranceData = (function () {
    function UtteranceData(vcc, appId, intentId, audioId, section, part, speaker, anchorOffset, focusOffset, currentTime, endCurrentTime, utteranceId, textContent, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.appId = appId;
        this.intentId = intentId;
        this.audioId = audioId;
        this.section = section;
        this.part = part;
        this.speaker = speaker;
        this.anchorOffset = anchorOffset;
        this.focusOffset = focusOffset;
        this.currentTime = currentTime;
        this.endCurrentTime = endCurrentTime;
        this.utteranceId = utteranceId;
        this.textContent = textContent;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
    }
    return UtteranceData;
}());
exports.UtteranceData = UtteranceData;
