"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SendIOEvents = void 0;
var server_config_1 = require("../config/server.config");
var log4js = require("log4js");
var promises_shared_1 = require("../shared/promises.shared");
var request_shared_1 = require("../shared/request.shared");
var logger = log4js.getLogger('IO');
function SendIOEvents(events) {
    return promises_shared_1.DummyPromise().then(function (_) {
        return request_shared_1.SimplePostRequest({
            uri: "http://" + server_config_1.HTTP_BINDING_HOST + ":" + server_config_1.HTTP_BINDING_PORT + "/io/send-events",
            body: JSON.stringify(events),
            headers: { 'Content-Type': 'application/json' }
        });
    }).then(function (result) {
        return result.data && result.data.status;
    }).catch(function (err) {
        logger.error("[io.requests::SendIOEvents] Error:", err);
        return false;
    });
}
exports.SendIOEvents = SendIOEvents;
